// set up a simple neutral simulation
initialize() {
	initializeMutationRate(1e-6);
	
	// m1 mutation type: neutral, domiance coefficient 0.5 and fixed selection coefficient of 0.0
	initializeMutationType("m1", 0.5, "f", 0.0); //non-coding or synonymous
	// m2 mutation type: dominance coefficient of 0.1, selection coefficient from exponential distribution "e" with mean of 0.1
	initializeMutationType("m2", 0.1, "e",0.1); //beneficial
	//m3 mutation type: dominance coefficient of 0.2,  and a DFE that is a gamma distribution ("g") with a mean of -0.03 and a shape parameter of 0.2
	initializeMutationType("m3", 0.2, "g", -0.03, 0.2); //deleterious
	
	
	// g1 genomic element type: uses m1 for all mutations (for non-coding regions)
	initializeGenomicElementType("g1", m1, 1.0);
	
	// g2 genomic elemeent: represents genic regions 
	//g2 will undergo all three types of mutations that are defined in m1,m2 and m3 in relative proportions of 100,1 and 10; for every hundred neutral (m1) mutations there will be on average one beneficial (m2) mutation and ten deleterious mutations (m3)
	initializeGenomicElementType("g2",c(m1,m2,m3), c(100,1,10));
	
	//g3 genomic element: represent introns
	//g3 will undergo 90% neutral mutations and 10% deleterious mutations(no beneficial mutations)
	//split upt the second genic region defined with g2 to now use g2 and g3 to define a structure of alternating exons(g2 and g3). Recycle
	initializeGenomicElementType("g3",c(m1,m3),c(90,10));
	
	
	// uniform chromosome of length 100 kb with uniform recombination
	initializeGenomicElement(g1, 0, 19999);
	initializeGenomicElement(g2, 20000, 21999);
	initializeGenomicElement(g3, 22000, 23999);
	initializeGenomicElement(g2, 24000, 29999);
	initializeGenomicElement(g1, 30000, 59999);
	initializeGenomicElement(g2, 60000, 79999);
	initializeGenomicElement(g1, 80000, 99999);
	initializeRecombinationRate(1e-8);
}

// create a population of 500 individuals
1 {
	sim.addSubpop("p1", 500);
}

// output samples of 10 genomes periodically, all fixed mutations at end
1000 late() { p1.outputSample(10); }
2000 late() { p1.outputSample(10); }
200000 late() { sim.outputFixedMutations(); }
